#!/usr/bin/env python3
# vi:si:et:sw=4:sts=4:ts=4

from setuptools import setup
import subprocess

def get_version():
    p = subprocess.Popen(['git', 'describe', '--tags', '--always'], stdout=subprocess.PIPE)
    v, e = p.communicate()
    return v.decode().strip()

setup(
    name="peerlink",
    version=get_version(),
    description='''peerlink - direct link for networked applications''',
    author="j",
    author_email="j@mailb.org",
    url="http://openmedialibrary.org/peerlink",
    download_url="http://git.0x2620.org/peerlink/download",
    license="GPLv3",
    scripts = [
        'bin/peerlink',
    ],
    packages=[
        'peerlink'
    ],
    install_requires=[
        'ed25519>=1.3',
        'pyopenssl>=0.14',
        'requests>=2.3.0',
        'tornado==4.0'
    ],
    keywords = [],
    classifiers = [
      'Operating System :: OS Independent',
      'Programming Language :: Python',
      'Programming Language :: Python :: 3',
      'Programming Language :: Python :: 3.4',
      'License :: OSI Approved :: GNU General Public License (GPL)',
    ],
)
